"use strict"; 
GR_GEO = function(){

    var $ = function(id){
	return document.getElementById(id);
    }


    var savePosition_Success = function(Y){
	return function(id,o){
	    alert(o.responseText);
	}
    }

    var savePosition_Failure = function(Y){
	return function(id,o){
	    alert('Connection error');
	}
    }

    var savePosition = function(Y, latitude, longitude){
	return function(e){
//	    var t = e.target;
//	    e.preventDefault();
//	    e.stopPropagation;
	    var cfg = {
		method: 'POST',
		data: 'latitude='+latitude+'&longitude='+longitude,
	        on : {
		    success : savePosition_Success(Y),
 	            failure : savePosition_Failure(Y)
	        }
	    }
	    Y.io("geo/server/geo.api.functions?action=saveposition", cfg); 
	}
    }

    var handleNoGeolocation = function(get_gigs_fn) {
	return function(errorFlag){
	    var content = '';
	    if (errorFlag) {
		content = 'Error: The Geolocation service failed.';
	    } else {
		content = 'Error: Your browser doesn\'t support geolocation.';
	    }
	    alert(content);
	    if(get_gigs_fn!=null){
		get_gigs_fn(-1,-1);
	    }
	}
    }

    var get_geocode_callback = function(Y){
	return function(latlng){
	    return function(geocoder){
		return function(results, status){
		    if (status == google.maps.GeocoderStatus.OK) {
			var loc = results[0].address_components[1].short_name+', '+results[0].address_components[2].short_name+', '+results[0].address_components[3].short_name;
			$('your_loc').innerHTML = "Your location (approx): "+loc;
		    }
		    else{
			alert('Geocode was not successful for the following reason: ' + status);
		    }
		}
	    }
	}
    }    

    var get_geocode = function(Y, address, callback){
	    var geocoder = new google.maps.Geocoder();
	    var cb = callback(geocoder);
	    geocoder.geocode( { 'address': address}, cb );
    }

    var getPositionCallback = function(Y, callback_fn, geocode_fn){
	return function(position){
	    //    navigator.geolocation.watchPosition(function(position) 
	    var latitude = position.coords.latitude; 
	    var longitude = position.coords.longitude;
	    if(geocode_fn==null){
		var geocode_fn = get_geocode_callback(Y);
	    }
	    get_geocode(Y, latitude+","+longitude, geocode_fn(latitude+","+longitude));
	    if(callback_fn){
		callback_fn(latitude, longitude);
	    }
	}
    }

    var getLatitudeAndLongitude = function(Y, callback_fn, geocode_fn){
	return function(e){
	    if(navigator.geolocation) {
		navigator.geolocation.getCurrentPosition(
		    getPositionCallback(Y, callback_fn, geocode_fn),
		    handleNoGeolocation(callback_fn),{ enableHighAccuracy: true});
	    }
	}
    }

    return{


	getPosition : function(){

	    return function(e){

		// All components: http://yuilibrary.com/yui/docs/guides/
		YUI().use("io", "dump", "json-parse", 'node', 'event', 'transition', 'node-load', 'anim',  function (Y) {
		    var get_gigs_fn = function(){
			return function(latitude, longitude){
			    get_gigs(Y, true, 1, 200, latitude, longitude)(null);
			}
		    }
		    getLatitudeAndLongitude(Y, get_gigs_fn(), null, get_gigs_fn())(null);

		});
	    }
	},


	getLatitudeLongitude : function(callback_fn){

	    return function(e){

		// All components: http://yuilibrary.com/yui/docs/guides/
		YUI().use("io", "dump", "json-parse", 'node', 'event', 'transition', 'node-load', 'anim',  function (Y) {

		    getLatitudeAndLongitude(Y, callback_fn, null, callback_fn);

		});
	    }

	},

	getDistance : function(lat1, lon1, lat2, lon2, unit) {

	    return function(e){

		// All components: http://yuilibrary.com/yui/docs/guides/
		YUI().use("io", "dump", "json-parse", 'node', 'event', 'transition', 'node-load', 'anim',  function (Y) {

		    var radlat1 = Math.PI * lat1/180
		    var radlat2 = Math.PI * lat2/180
		    var radlon1 = Math.PI * lon1/180
		    var radlon2 = Math.PI * lon2/180
		    var theta = lon1-lon2
		    var radtheta = Math.PI * theta/180
		    var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
		    dist = Math.acos(dist)
		    dist = dist * 180/Math.PI
		    dist = dist * 60 * 1.1515
		    if (unit=="K") { dist = dist * 1.609344 }
		    if (unit=="N") { dist = dist * 0.8684 }
		    return dist


		});

	    }

	},




        
    };

}();


