<?php

function e000error_customErrorHandler($errno, $errstr, $errfile, $errline)
{

  $action = isset($_GET['action'])?$_GET['action']:"unknown";
		
  $description = "";
		
  //		echo($errno) . " ";
		
  if(in_array($errno, array(E_USER_ERROR, E_USER_WARNING, E_USER_NOTICE, 2, 8))){ //8
			
    $trace = array_reverse(debug_backtrace());
			
    $description = "<table width='100%' class='error_table' border='0' cellpadding='2px'>
			    <tr>
			        <td class='heading'>File</td><td class='heading'>Line</td><td class='heading'>Function</td>
			    </tr>";
			
    foreach($trace as $item){
      $description .= "<tr valign='top'><td>" . (isset($item["file"])?$item["file"]:"---") . "</td><td>"; 
      $description .= (isset($item["line"])?"Line:".$item["line"]:"---") . "</td><td>";
      $description .= (isset($item["function"])?$item["function"]."()":"---") . "</td>";		
      $description .= "</tr>";
    }
		
    $description .= "</table>";
			
    switch ($errno) {
		    
    case E_USER_ERROR:
      $description .= "<b>ERROR</b> [$errno] $errstr<br />\n";
      $description .= "  Fatal error on line $errline in file $errfile";
      $description .= ", PHP " . PHP_VERSION . " (" . PHP_OS . ")<br />\n";
      $description .= "Aborting&hellip;<br />\n";
      //exit(1);
      break;
		
    case E_USER_WARNING:
      $description .= "<b>WARNING</b> [$errno] $errstr<br />\n";
      break;
		
    case E_USER_NOTICE:
      $description .= "<b>NOTICE</b> [$errno] $errstr<br />\n";
      break;
		
    case 2:
      $description .= "Unknown error type: [$errno] $errstr<br />\n";
      $description .= "Aborting&hellip;<br />\n";
      break;
    case 8:
      $description .= "Unknown error type: [$errno] $errstr<br />\n";
      $description .= "Aborting&hellip;<br />\n";		    	
      break;
    default:
      $description .= "Unknown error type: [$errno] $errstr<br />\n";
      break;
    }
  }

  if(!empty($description) && strpos($description, "SSL: fatal protocol error")===false){
			
    if(isset($_SERVER["REMOTE_ADDR"]) && $_SERVER["REMOTE_ADDR"] == "127.0.0.1"){
      echo $description;
    }
    else{ 
	echo $description;
    }
			
    if(E_USER_ERROR == $errno || 2 == $errno || 8 == $errno){
      if(ob_get_level()>1){
	ob_end_flush();
      }
      exit(1);
    }
			
  }
  /* Don't execute PHP internal error handler */
  return true;
}


set_error_handler("e000error_customErrorHandler");


?>