"use strict"; 
CBP_DASHBOARD = function(){

    var $ = function(id){
	return document.getElementById(id);
    }

    var renderNichesCharts = function(Y, stats){

	var trader_niches = stats.trader_niches;
	var trade_partner_niches = stats.trade_partner_niches;
	var most_popular_niches = stats.most_popular_niches;

	for(key in trader_niches){
	    trader_niches[key][1] = trader_niches[key][1]*1;
	}

	for(key in trade_partner_niches){
	    trade_partner_niches[key][1] = trade_partner_niches[key][1]*1;
	}

	for(key in most_popular_niches){
	    most_popular_niches[key][1] = most_popular_niches[key][1]*1;
	}

        var pie_chart_trader_niches_data = new google.visualization.DataTable();
        pie_chart_trader_niches_data.addColumn('string', 'Niches');
        pie_chart_trader_niches_data.addColumn('number', 'Action');
        pie_chart_trader_niches_data.addRows(trader_niches);
        var pie_chart_trader_niches_options = {'title':'Your niches',
					'width':400,
					'height':300};
	drawPieChart(Y, stats, pie_chart_trader_niches_data, pie_chart_trader_niches_options, $('cbp_pie_chart_trader_niches_container'));

        var pie_chart_trade_partner_niches_data = new google.visualization.DataTable();
        pie_chart_trade_partner_niches_data.addColumn('string', 'Niches');
        pie_chart_trade_partner_niches_data.addColumn('number', 'Action');
        pie_chart_trade_partner_niches_data.addRows(trade_partner_niches);
        var pie_chart_trade_partner_niches_options = {'title':'Trade partner niches',
					'width':400,
					'height':300};
	drawPieChart(Y, stats, pie_chart_trade_partner_niches_data, pie_chart_trade_partner_niches_options, $('cbp_pie_chart_trade_partner_niches_container'));

        var pie_chart_most_popular_niches_data = new google.visualization.DataTable();
        pie_chart_most_popular_niches_data.addColumn('string', 'Niches');
        pie_chart_most_popular_niches_data.addColumn('number', 'Action');
        pie_chart_most_popular_niches_data.addRows(most_popular_niches);
        var pie_chart_most_popular_niches_options = {'title':'Most popular',
					'width':400,
					'height':300};
	drawPieChart(Y, stats, pie_chart_most_popular_niches_data, pie_chart_most_popular_niches_options, $('cbp_pie_chart_most_popular_niches_container'));



    }


    var renderOffersCharts = function(Y, stats){

	var offers_accepted = stats.offers_accepted*1;
	var offers_pending = stats.offers_pending*1;
	var offers_rejected = stats.offers_rejected*1;	    
	var total_offers = offers_accepted+offers_rejected+offers_pending;

	var offers_ratio = null;
	var offers_accepted_perc = total_offers>0?offers_accepted / total_offers * 100:0;
	var offers_rejected_perc = total_offers>0?offers_rejected / total_offers * 100:0;
	var offers_pending_perc = total_offers>0?offers_pending / total_offers * 100:0;

        if(offers_accepted_perc > offers_rejected_perc){
	    offers_ratio =  offers_accepted_perc>0?(((offers_rejected_perc / offers_accepted_perc)*100)):0;
	}
	else{
	    offers_ratio = offers_rejected_perc>0?100 - (((offers_accepted_perc / offers_rejected_perc)*100)):0;
	}

        var pie_chart_offers_data = new google.visualization.DataTable();
        pie_chart_offers_data.addColumn('string', 'Offers');
        pie_chart_offers_data.addColumn('number', 'Action');
        pie_chart_offers_data.addRows([
	    ['Offers accepted', offers_accepted],
	    ['Offers rejected', offers_rejected],
	    ['Offers pending', offers_pending]
        ]);
        var pie_chart_offers_options = {'title':'Offers',
					'width':400,
					'height':300};

	drawPieChart(Y, stats, pie_chart_offers_data, pie_chart_offers_options, $('cbp_pie_chart_offers_container'));

	var gauge_chart_offers_data = google.visualization.arrayToDataTable([
	    ['Label', 'Value'],
	    ['Offers ratio', Math.round(offers_ratio)],
	    ['Offers accepted %', Math.round(offers_accepted_perc)],
	    ['Offers rejected %', Math.round(offers_rejected_perc)],
	    ['Offers pending %', Math.round(offers_pending_perc)],
        ]);

        var gauge_chart_offers_options = {
	    width: 700, height: 420,
	    redFrom: 80, redTo: 100,
	    yellowFrom: 60, yellowTo: 80,
	    minorTicks: 5
        };

	drawGaugeChart(Y, stats, gauge_chart_offers_data, gauge_chart_offers_options, $('cbp_gauge_chart_offers_container'));

        var bar_chart_offers_data = google.visualization.arrayToDataTable([
	    ['', ''],
	    ['Offers accepted', offers_accepted],
	    ['Offers rejected', offers_rejected]
        ]);
        var bar_chart_offers_options = {
	    title: 'Offers'
        };
	drawBarChart(Y, stats, bar_chart_offers_data, bar_chart_offers_options, $('cbp_bar_chart_offers_container'));


	for(key in stats.offers_countries){
	    if(key>0){
		stats.offers_countries[key][1] = stats.offers_countries[key][1]*1;
	    }
	}
        var geo_chart_offers_data = google.visualization.arrayToDataTable([
	    stats.offers_countries
        ]);

        var geo_chart_offers_options = {};
        drawGeoChart(Y, stats, geo_chart_offers_data, geo_chart_offers_options, $('cbp_geo_chart_offers_container'));

	for(key in stats.offers_by_month){
	    if(key>0){
		stats.offers_by_month[key][1] = stats.offers_by_month[key][1]*1;
		stats.offers_by_month[key][2] = stats.offers_by_month[key][2]*1;
		stats.offers_by_month[key][3] = stats.offers_by_month[key][3]*1;
	    }
	}
        var area_chart_offers_data = google.visualization.arrayToDataTable([
	    ['Month', 'Offers accepted', 'Offers declined', 'Offers pending'],
	    ['January', 0,0,0]
        ]);
        var area_chart_offers_options = {
	    title: 'Offers',
	    hAxis: {title: 'Month',  titleTextStyle: {color: '#333'}},
	    vAxis: {minValue: 0}
        };
        drawAreaChart(Y, stats, area_chart_offers_data, area_chart_offers_options, $('cbp_area_chart_offers_container'));

    }

    var renderClicksCharts = function(Y, stats){

	var clicks_sent = stats.clicks_sent*1;
	var clicks_owing = stats.clicks_owing*1;
	var clicks_received = stats.clicks_received*1;	    
	var clicks_owed = stats.clicks_owed*1;	    
	var total_clicks_sent = clicks_sent+clicks_received*1;
	var total_clicks_owed_owing = clicks_owed+clicks_owing*1;
	var clicks_ratio = null;
	var clicks_owed_owing_ratio = null;
	var clicks_sent_perc = total_clicks_sent > 0?clicks_sent / total_clicks_sent * 100:0
	var clicks_owing_perc = total_clicks_owed_owing > 0?clicks_owing / total_clicks_owed_owing * 100:0;
	var clicks_received_perc = total_clicks_sent > 0?clicks_received / total_clicks_sent * 100:0;
	var clicks_owed_perc = total_clicks_owed_owing > 0?clicks_owed / total_clicks_owed_owing * 100:0;

        if(clicks_sent_perc > clicks_received_perc){
	    clicks_ratio =  clicks_sent_perc>0?(((clicks_received_perc / clicks_sent_perc)*100)):0;
	}
	else{
	    clicks_ratio = clicks_received_perc>0?100 - (((clicks_sent_perc / clicks_received_perc)*100)):0;
	}

        if(clicks_owing_perc > clicks_owed_perc){
	    clicks_owed_owing_ratio =  clicks_owing_perc > 0?(((clicks_owed_perc / clicks_owing_perc)*100)):0;
	}
	else{
	    clicks_owed_owing_ratio = clicks_owed_perc>0?100 - (((clicks_owing_perc / clicks_owed_perc)*100)):0;
	}


        var pie_chart_clicks_data = new google.visualization.DataTable();
        pie_chart_clicks_data.addColumn('string', 'Clicks');
        pie_chart_clicks_data.addColumn('number', 'Action');
        pie_chart_clicks_data.addRows([
	    ['Clicks sent', clicks_sent],
	    ['Clicks received', clicks_received],
        ]);

        var pie_chart_clicks_options = {'title':'Clicks',
					'width':400,
					'height':300};

	drawPieChart(Y, stats, pie_chart_clicks_data, pie_chart_clicks_options, $('cbp_pie_chart_clicks_container'));


        var pie_chart_clicks_o_data = new google.visualization.DataTable();
        pie_chart_clicks_o_data.addColumn('string', 'Clicks');
        pie_chart_clicks_o_data.addColumn('number', 'Action');
        pie_chart_clicks_o_data.addRows([
	    ['Clicks owing', clicks_owing],
	    ['Clicks owed', clicks_owed],
        ]);

        var pie_chart_clicks_o_options = {'title':'Clicks owed/owing',
					  'width':400,
					  'height':300};

	drawPieChart(Y, stats, pie_chart_clicks_o_data, pie_chart_clicks_o_options, $('cbp_pie_chart_clicks_o_container'));


	/*
	  A gauge measuring the user's clicks sent to clicks received ratio. If the gauge is low then the user has high clicks sent to clicks received ratio. If the gauge is high then the user has a low clicks sent to clicks received ratio (ie they need to send more clicks).

	*/

	var gauge_chart_clicks_data = google.visualization.arrayToDataTable([
	    ['Label', 'Value'],
	    ['Clicks ratio', Math.round(clicks_ratio)],
	    ['Clicks sent %', Math.round(clicks_sent_perc)],
	    ['Clicks received %', Math.round(clicks_received_perc)],
	    ['Clicks owed/owing ratio', Math.round(clicks_owed_owing_ratio)],
	    ['Clicks owing %', Math.round(clicks_owing_perc)],
	    ['Clicks owed %', Math.round(clicks_owed_perc)],
        ]);

        var gauge_chart_clicks_options = {
	    width: 700, height: 420,
	    redFrom: 80, redTo: 100,
	    yellowFrom: 60, yellowTo: 80,
	    minorTicks: 5
        };

	drawGaugeChart(Y, stats, gauge_chart_clicks_data, gauge_chart_clicks_options, $('cbp_gauge_chart_clicks_container'));



        var bar_chart_clicks_data = google.visualization.arrayToDataTable([
	    ['', ''],
	    ['Clicks sent', clicks_sent],
	    ['Clicks received', clicks_received]
        ]);
        var bar_chart_clicks_options = {
	    title: 'Clicks'
        };
	drawBarChart(Y, stats, bar_chart_clicks_data, bar_chart_clicks_options, $('cbp_bar_chart_clicks_container'));


        var bar_chart_clicks_o_data = google.visualization.arrayToDataTable([
	    ['', ''],
	    ['Clicks owed', clicks_sent],
	    ['Clicks owing', clicks_owing]
        ]);
        var bar_chart_clicks_o_options = {
	    title: 'Clicks owed/owing'
        };
	drawBarChart(Y, stats, bar_chart_clicks_o_data, bar_chart_clicks_o_options, $('cbp_bar_chart_clicks_o_container'));

	for(key in stats.clicks_countries){
	    if(key>0){
		stats.clicks_countries[key][1] = stats.clicks_countries[key][1]*1;
	    }
	}
        var geo_chart_clicks_data = google.visualization.arrayToDataTable([
	    stats.clicks_countries
        ]);
        var geo_chart_clicks_options = {};
        drawGeoChart(Y, stats, geo_chart_clicks_data, geo_chart_clicks_options, $('cbp_geo_chart_clicks_container'));

	var clicks_months = [];
	for(key in stats.clicks_by_month){
	    if(key==0){
		clicks_months[0] = stats.clicks_by_month[0];
	    }
	    else{
		clicks_months[key] = [];
		clicks_months[key][0] = 'February';
		clicks_months[key][1] = 1;
		clicks_months[key][2] = 1;
	    }
	}
        var area_chart_clicks_data = google.visualization.arrayToDataTable([
	    ['Month', 'Clicks sent', 'Clicks received'],
            ['January', 0, 0]
        ]);

/*
        var area_chart_clicks_data = google.visualization.arrayToDataTable([
	    ['Month', 'Clicks sent', 'Clicks received'],
	    ['January',  clicks_sent,      clicks_received],
	    ['February',  1170,      460],
	    ['March',  660,       1120],
	    ['April',  1030,      540]
        ]);
*/
        var area_chart_clicks_options = {
	    title: 'Clicks',
	    hAxis: {title: 'Month',  titleTextStyle: {color: '#333'}},
	    vAxis: {minValue: 0}
        };
        drawAreaChart(Y, stats, area_chart_clicks_data, area_chart_clicks_options, $('cbp_area_chart_clicks_container'));


        var area_chart_clicks_o_data = google.visualization.arrayToDataTable([
	    ['Month', 'Clicks owed', 'Clicks owing'],
	    ['January',  clicks_owed,      clicks_owing],
	    ['February',  888,      460],
	    ['March',  660,       1120],
	    ['April',  1030,      540]
        ]);
        var area_chart_clicks_o_options = {
	    title: 'Clicks owed/owing',
	    hAxis: {title: 'Month',  titleTextStyle: {color: '#333'}},
	    vAxis: {minValue: 0}
        };
//        drawAreaChart(Y, stats, area_chart_clicks_o_data, area_chart_clicks_o_options, $('cbp_area_chart_clicks_o_container'));


	var timeline_dataTable = new google.visualization.DataTable();

	timeline_dataTable.addColumn({ type: 'string', id: 'President' });
	timeline_dataTable.addColumn({ type: 'date', id: 'Start' });
	timeline_dataTable.addColumn({ type: 'date', id: 'End' });

	timeline_dataTable.addRows([
	    [ 'Washington', new Date(1789, 3, 29), new Date(1797, 2, 3) ],
	    [ 'Adams',      new Date(1797, 2, 3),  new Date(1801, 2, 3) ],
	    [ 'Jefferson',  new Date(1801, 2, 3),  new Date(1809, 2, 3) ]]);


	var timeline_options = {
	    timeline: { showRowLabels: true }
	};

	//	    drawTimelineChart(Y, stats, timeline_dataTable, timeline_options, $('cbp_timeline_chart_container'));


    }

    var drawTimelineChart = function(Y, stats, data, options, timeline_chart_container){
        var chart = new google.visualization.Timeline(timeline_chart_container);
        chart.draw(data, options);
    }

    var drawAreaChart = function(Y, stats, data, options, area_chart_container){
        var chart = new google.visualization.AreaChart(area_chart_container);
        chart.draw(data, options);
    }

    var drawGeoChart = function(Y, stats, data, options, geo_chart_container){
        var chart = new google.visualization.GeoChart(geo_chart_container);
        chart.draw(data, options);
    }

    var drawBarChart = function(Y, stats, data, options, bar_chart_container){
        var chart = new google.visualization.BarChart(bar_chart_container);
        chart.draw(data, options);
    }

    var drawGaugeChart = function(Y, stats, data, options, gauge_chart_container){
        var chart = new google.visualization.Gauge(gauge_chart_container);
	chart.max = 3000;
        chart.draw(data, options);
    }

    var drawPieChart = function(Y, stats, data, options, pie_chart_container){
        var chart = new google.visualization.PieChart(pie_chart_container);
        chart.draw(data, options);
    }

    var get_stats_Success = function(Y){
	return function(id,o){
//	    	    alert(o.responseText);
	    //	    alert($('cbp_charts_container'));
	    //            var chart = new google.visualization.PieChart($('cbp_charts_container'));
	    //	    alert(chart);

	    var stats = Y.JSON.parse(o.responseText);

	    renderClicksCharts(Y, stats);
	    renderOffersCharts(Y, stats);
            renderNichesCharts(Y, stats);

//	    $('cbp_stats_container').innerHTML = o.responseText;
	}
    }

    var get_stats_Failure = function(Y){
	return function(id,o){
	    alert('Connection error');
	}
    }

    var get_stats = function(Y){
	return function(e){
	    //	    var t = e.target;
	    //	    e.preventDefault();
	    //	    e.stopPropagation;
	    var cfg = {
		method: 'GET',
		data: 'var1=var2',
	        on : {
		    success : get_stats_Success(Y),
 	            failure : get_stats_Failure(Y)
	        }
	    }
	    Y.io("clickbosspro/dashboard/server/dashboard.api.php?action=getstats", cfg); 
	}
    }

    return{

	init : function(settings, site_url, jQuery){

	    return function(e){

		// All components: http://yuilibrary.com/yui/docs/guides/
		YUI().use("io", "dump", "json-parse", 'node', 'event', 'transition', 'node-load', 'anim',  function (Y) {

		    get_stats(Y)(null);

		});

	    }

	},

        
    };

}();


