<?php
if(!class_exists('crcrYouTube'))
{
    class crcrYouTube{
      function __construct(){}
      
      public function parseSearchResults($search_results, $translate, $translate_source){
        $results = array();
        if(is_object($search_results)){
            if(isset($search_results->items))
            {
              $videos = $search_results->items;
              foreach($videos as $video){
                  $description = $video->snippet->description;
				  if($translate != 'disabled' && $translate != '')
				  {
						if($translate_source != '' && $translate_source != 'disabled')
						{
							$from = $translate_source;
						}
						else
						{
							$from = 'en';
						}
						$translation = smp_translate($description, $from, $translate);
						if ($translation !== FALSE) 
						{
							if ($translation != '') {
								$description = str_replace('</ iframe>', '</iframe>', $translation);
								if(stristr($description, '<head>') !== false)
								{
									$d = new DOMDocument;
									$mock = new DOMDocument;
									$d->loadHTML('<?xml encoding="utf-8" ?>' . $description);
									$body = $d->getElementsByTagName('body')->item(0);
									foreach ($body->childNodes as $child)
									{
										$mock->appendChild($mock->importNode($child, true));
									}
									$new_post_content_temp = $mock->saveHTML();
									if($new_post_content_temp !== '' && $new_post_content_temp !== false)
									{
										$new_post_content_temp = str_replace('<?xml encoding="utf-8" ?>', '', $new_post_content_temp);
										$description = preg_replace("/_addload\(function\(\){([^<]*)/i", "", $new_post_content_temp); 
									}
								}
								$description = htmlspecialchars_decode($description);
								$description = str_replace('</ ', '</', $description);
								$description = str_replace(' />', '/>', $description);
								$description = str_replace('< br/>', '<br/>', $description);
								$description = str_replace('< / ', '</', $description);
								$description = str_replace(' / >', '/>', $description);
								$description = str_replace('</??????h2>', '</h2>', $description);
								$description = str_replace('</??????h2>', '</h2>', $description);
								$description = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $description);
							} else {
								smp_log_to_file('Translation failed - malformed data!');
							}
						} else {
							smp_log_to_file('Translation Failed - returned false!');
						}
			      }
                  $text = substr(strip_tags($description), 0, 100);
                  $content_short = substr($text,0,strrpos($text," "));
                  $img_url = $video->snippet->thumbnails->high->url;
                  $title = $video->snippet->title;
                  $video_id = $video->id->videoId;
                  $url = "http://www.youtube.com/watch?v=$video_id";
                  $results[] = array('image' => $img_url, 'url'=>$url, 'title'=>str_replace(array("&#39;", "&amp;", "&quot;"), array("'", "&", '"'), strip_tags($title)), 'description'=>str_replace(array("&#39;", "&amp;", "&quot;"), array("'", "&", '"'), strip_tags($description)), 'preview'=>$content_short, 'youtube_id'=>$video_id);
                }
            }
            else
            {
                smp_log_to_file('Unrecognized response from YouTube: ' . print_r($search_results, true));
            }
        }
        return $results;
      }
      
      public function search($youtube_api_key, $keywords, $n=25, $translate, $translate_source){
        $keywords = urlencode($keywords);  
        $search_results = $this->getRemoteFileCurl("https://www.googleapis.com/youtube/v3/search?key=$youtube_api_key&q=$keywords&part=snippet&maxResults=$n", "GET", array());
        $search_results = json_decode($search_results);
        $products =  $this->parseSearchResults($search_results, $translate, $translate_source);
        $results['paragraphs'] = $products;
        return $results;
      }

      public function getRemoteFileCurl($url, $method, $postFields, $referrer="", $userAgent="", $username=null, $password=null, $headers=false, $customHeaders=null){
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_COOKIEFILE, 'xcookie.txt');  
        curl_setopt($ch, CURLOPT_COOKIEJAR, 'xcookie.txt');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        if(empty($customHeaders)){
          $customHeaders = array('Expect: ');
        }
        else{
          $customHeaders[] = 'Expect: ';
        }
        curl_setopt($ch, CURLOPT_HTTPHEADER, $customHeaders); 
        curl_setopt($ch, CURLOPT_HEADER, $headers);
        if(!empty($referrer)){
          curl_setopt($ch, CURLOPT_REFERER, $referrer);
        }
        if(!empty($userAgent)){
          curl_setopt($ch, CURLOPT_USERAGENT, $userAgent);
        }
        if(!empty($username)){
          curl_setopt($ch, CURLOPT_USERPWD, "$username:$password");   
        }
        if(strtoupper($method)=='POST'){
          curl_setopt($ch, CURLOPT_POST, 1);
          if(!empty($postFields)){
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postFields);
          }
        }
        $content = curl_exec($ch);
        curl_close($ch);
        return $content;
     
      }
    }
}

?>