<?php
   use DirkGroenen\Pinterest\Pinterest;
   if(is_admin())
{
   $smp_options = get_option('SMP_Options_General', false);
   $pin_redirect = admin_url('admin.php?page=smp_pinterest_panel&fb_auth_done=true');
   $pin_redirect = preg_replace("/^http:/i", "https:", $pin_redirect);
   if(isset($_POST['smp_auth']))
   {
       $smp_unique_id = md5(uniqid(rand(), TRUE));
       setcookie("smp_unique_id", $smp_unique_id, "0", "/");
       try
       {
           require_once(dirname(__FILE__) . "/Pinterest/autoload.php");
           $pinterest = new Pinterest($smp_options['app_id'], $smp_options['app_secret']);
           $redir_url = $pinterest->auth->getLoginUrl($pin_redirect, array('read_public,write_public'));
           if(!function_exists('wp_redirect'))
           {
               include_once( ABSPATH . 'wp-includes/pluggable.php' );
           }
           wp_redirect($redir_url);
           exit();
       }
       catch(Exception $e)
       {
           smp_log_to_file('Exception thrown in Pinterest/getLoginUrl: ' . $e->getMessage());
       }
   }
   if(isset($_GET["code"])){
       try
       {
           require_once(dirname(__FILE__) . "/Pinterest/autoload.php");
           $pinterest = new Pinterest($smp_options['app_id'], $smp_options['app_secret']);
           $token = $pinterest->auth->getOAuthToken($_GET["code"]);
           $pinterest->auth->setOAuthToken($token->access_token);
           update_option('smp_access_token',$token->access_token);
           update_option('smp_auth_id',$smp_options['app_id']);
           update_option('smp_auth_secret',$smp_options['app_secret']);
           $public_boards = array();
           $boards = $pinterest->users->getMeBoards();
           foreach ($boards as $board_key => $board) {
               $public_boards[$board->id] = $board->name;
           }
           update_option('smp_public_boards', $public_boards);
           $final_url = admin_url('admin.php?page=smp_pinterest_panel&fb_auth_done=true');
           if(!function_exists('wp_redirect'))
           {
               include_once( ABSPATH . 'wp-includes/pluggable.php' );
           }
           wp_redirect($final_url);
           exit();
       }
       catch(Exception $e)
       {
           if(stristr($e->getMessage(), 'invalid_grant') !== false)
           {
               smp_log_to_file('Failed to authorize request with Pinterest. Please try again.');
           }
           else
           {
               smp_log_to_file('Exception thrown in Pinterest/getAccessToken: ' . $e->getMessage());
           }
       }
   }
}
   function smp_pinterest_panel()
   {
   $smp_options = get_option('SMP_Options_General', false);
   if (isset($smp_options['posting_method']) && $smp_options['posting_method'] == 'cred') {
       if (!isset($smp_options['user_name']) || $smp_options['user_name'] == '') {
   ?>
<h1><?php echo esc_html__("You must add a Pinterest User Name before you can use this feature!", 'smp-youtube-mass-poster');?></h1>
<?php
   return;
   }
   if (!isset($smp_options['user_pass']) || $smp_options['user_pass'] == '') {
   ?>
<h1><?php echo esc_html__("You must add a Pinterest User Password before you can use this feature!", 'smp-youtube-mass-poster');?></h1>
<?php
   return;
   }
   $authorized = true;
   }
   else
   {
   $authorized = false;
   if(isset($smp_options['app_id']) && $smp_options['app_id'] != '')
   {
   if(isset($smp_options['app_secret']) && $smp_options['app_secret'] != '')
   {
   $GLOBALS['wp_object_cache']->delete('smp_auth_id', 'options');
   $GLOBALS['wp_object_cache']->delete('smp_auth_secret', 'options');
   if(get_option('smp_auth_id', false) !== FALSE)
   {
       if(get_option('smp_auth_secret', false) !== FALSE)
       {
           if($smp_options['app_id'] == get_option('smp_auth_id', false) && $smp_options['app_secret'] == get_option('smp_auth_secret', false) && get_option('smp_access_token', false) != '')
           {
               $authorized = true;
           }
       }
   }
   }
   else
   {
   ?>
<h1><?php echo esc_html__("You must add a Pinterest App Secret before you can use this feature!", 'smp-youtube-mass-poster');?></h1>
<?php
   update_option('smp_auth_id', 'null');
   update_option('smp_auth_secret', 'null');
   return;
   }
   }
   else
   {
   ?>
<h1><?php echo esc_html__("You must add a Pinterest App ID and Secret before you can use this feature!", 'smp-youtube-mass-poster');?></h1>
<?php
   update_option('smp_auth_id', 'null');
   update_option('smp_auth_secret', 'null');
   return;
   }
   if($authorized === FALSE)
   {
   ?>
<div class="hideThis">
   <h1><?php echo esc_html__("Some Required Steps Before You Can Use This Feature:", 'smp-youtube-mass-poster');?></h1>
   <b>1)</b> <?php echo esc_html__("If your website does not support HTTPS protocol, to make the auth work, when you are redirected after Pinterest auth, simply delete the 'S' from 'HTTPS' and leave just 'HTTP' at the beginning of the URL where you got redirected.", 'smp-youtube-mass-poster');?><br/>
   <b>2)</b> <?php echo esc_html__("You have to create a Pinterest App before filling the following details.", 'smp-youtube-mass-poster');?></i>
   <b><a href="https://developers.pinterest.com/apps" target="_blank"><?php echo esc_html__("Click here", 'smp-youtube-mass-poster');?></a></b><?php echo esc_html__("to create new Pinterest App. ", 'smp-youtube-mass-poster');?>		
   <br><b>3)</b> <?php echo esc_html__("In the Pinterest application, set 'Redirect URIs' as: ", 'smp-youtube-mass-poster');?>
   <span class="cr_red"><?php $url = preg_replace("/^http:/i", "https:", $GLOBALS['pin_redirect']);echo $url;?></span>
   <br/><b>4)</b> <strong><?php echo esc_html__("Authorize Your App to Post on Pinterest:", 'smp-youtube-mass-poster');?></strong>
</div>
<br/><b>5)</b> <strong><?php echo esc_html__("Important:", 'smp-youtube-mass-poster');?></strong> <i><?php echo esc_html__("if your web site does not support HTTPS", 'smp-youtube-mass-poster');?></i>, <?php echo esc_html__("after you click 'Accept' for the Pinterest authentification, the redirect link will not work. In this case, simply change in the URL after you clicked accept and were redirected: from HTTPS to HTTP (do not change anything else in the URL!) and the authorization will work.", 'smp-youtube-mass-poster');?></div><br/>
<?php
   }
   else
   {
   ?>
<br/><br/>
<?php
   }
   ?>
<form id="myForm2" method="post" action=""><input type="submit" name="smp_auth" id="btnSubmit" class="button button-primary" onclick="unsaved = false;" value="<?php if($authorized === TRUE){echo esc_html__('Reauthorize the App', 'smp-youtube-mass-poster');}else{echo esc_html__('Authorize the App', 'smp-youtube-mass-poster');}?>"/></form>
<?php
   if(isset($_REQUEST['fb_auth_done']))
   {
   ?>
<div id="message" class="updated">
   <p class="cr_saved_notif"><strong>&nbsp;<i><?php echo esc_html__("Pinterest authorization successful!", 'smp-youtube-mass-poster');?></i></strong></p>
</div>
<?php
   }
   }
   if($authorized === TRUE)
   {
   ?>
<form id="myForm" method="post" action="<?php if(is_multisite() && is_network_admin()){echo '../options.php';}else{echo 'options.php';}?>">
   <?php
      settings_fields('smp_option_group2');
      do_settings_sections('smp_option_group2');
      $smp_Pinterest_Settings = get_option('smp_Pinterest_Settings', false);
      if (isset($smp_Pinterest_Settings['smp_posting'])) {
          $smp_posting = $smp_Pinterest_Settings['smp_posting'];
      } else {
          $smp_posting = '';
      }
      if (isset($smp_Pinterest_Settings['pinterest_format'])) {
          $pinterest_format = $smp_Pinterest_Settings['pinterest_format'];
      } else {
          $pinterest_format = '';
      }
      if (isset($smp_Pinterest_Settings['pin_urls'])) {
          $pin_urls = $smp_Pinterest_Settings['pin_urls'];
      } else {
          $pin_urls = '';
      }
      if (isset($smp_Pinterest_Settings['single_random'])) {
          $single_random = $smp_Pinterest_Settings['single_random'];
      } else {
          $single_random = '';
      }
      if (isset($smp_Pinterest_Settings['pin_each'])) {
          $pin_each = $smp_Pinterest_Settings['pin_each'];
      } else {
          $pin_each = '';
      }
      if (isset($smp_Pinterest_Settings['post_posts'])) {
          $post_posts = $smp_Pinterest_Settings['post_posts'];
      } else {
          $post_posts = '';
      }
      if (isset($smp_Pinterest_Settings['post_pages'])) {
          $post_pages = $smp_Pinterest_Settings['post_pages'];
      } else {
          $post_pages = '';
      }
      if (isset($smp_Pinterest_Settings['post_custom'])) {
          $post_custom = $smp_Pinterest_Settings['post_custom'];
      } else {
          $post_custom = '';
      }
      if (isset($smp_Pinterest_Settings['except_type'])) {
          $except_type = $smp_Pinterest_Settings['except_type'];
      } else {
          $except_type = '';
      }
      if (isset($smp_Pinterest_Settings['disabled_categories'])) {
          $disabled_categories = $smp_Pinterest_Settings['disabled_categories'];
      } else {
          $disabled_categories = '';
      }
      if (isset($smp_Pinterest_Settings['disable_tags'])) {
          $disable_tags = $smp_Pinterest_Settings['disable_tags'];
      } else {
          $disable_tags = '';
      }
      if (isset($smp_Pinterest_Settings['only_local'])) {
          $only_local = $smp_Pinterest_Settings['only_local'];
      } else {
          $only_local = '';
      }
      if (isset($smp_Pinterest_Settings['proxy_list'])) {
          $proxy_list = $smp_Pinterest_Settings['proxy_list'];
      } else {
          $proxy_list = '';
      }
      if (isset($smp_Pinterest_Settings['board_select'])) {
          $board_select = $smp_Pinterest_Settings['board_select'];
      } else {
          $board_select = '';
      }
      if (isset($smp_Pinterest_Settings['delay_post'])) {
          $delay_post = $smp_Pinterest_Settings['delay_post'];
      } else {
          $delay_post = '';
      }
      if (isset($_GET['settings-updated'])) {
      ?>
   <div id="message" class="updated">
      <p class="cr_saved_notif"><strong>&nbsp;<?php echo esc_html__('Settings saved.', 'smp-youtube-mass-poster');?></strong></p>
   </div>
   <?php
      $get = get_option('coderevolution_settings_changed', 0);
      if($get == 1)
      {
          delete_option('coderevolution_settings_changed');
      ?>
   <div id="message" class="updated">
      <p class="cr_failed_notif"><strong>&nbsp;<?php echo esc_html__('Plugin registration failed!', 'smp-youtube-mass-poster');?></strong></p>
   </div>
   <?php 
      }
      elseif($get == 2)
      {
              delete_option('coderevolution_settings_changed');
      ?>
   <div id="message" class="updated">
      <p class="cr_saved_notif"><strong>&nbsp;<?php echo esc_html__('Plugin registration successful!', 'smp-youtube-mass-poster');?></strong></p>
   </div>
   <?php 
      }
      elseif($get != 0)
      {
              delete_option('coderevolution_settings_changed');
      ?>
   <div id="message" class="updated">
      <p class="cr_failed_notif"><strong>&nbsp;<?php echo esc_html($get);?></strong></p>
   </div>
   <?php 
      }
          }
      ?>
   <div>
      <div class="smp_class">
         <table class="widefat">
            <tr>
               <td>
                  <h1>
                     <span class="gs-sub-heading"><b><?php echo esc_html__("Auto Pin to Pinterest:", 'smp-youtube-mass-poster');?></b>&nbsp;</span>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Enable or disable automatic posting to Pinterest every time you access a new post with the [smp] shortcode in it (manually or automatically).", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                  </h1>
               </td>
               <td>
                  <div class="slideThree">	
                     <input class="input-checkbox" type="checkbox" id="smp_posting" name="smp_Pinterest_Settings[smp_posting]" onChange="mainChanged()"<?php
                        if ($smp_posting == 'on')
                            echo ' checked ';
                        ?>>
                     <label for="smp_posting"></label>
                  </div>
               </td>
            </tr>
         </table>
      </div>
      <div class="hideMain">
         <hr/>
         <table class="widefat">
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want delay posting with this amount of seconds from post publish? This will create a single cron job for each post (cron is a requirement for this to function). If you leave this field blank, posts will be automatically published on post creation.", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Delay Posting By (Seconds):", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <input type="number" min="0" step="1" class="cr_width_full" id="delay_post" name="smp_Pinterest_Settings[delay_post]" class="cr_450" value="<?php echo esc_html($delay_post);?>" placeholder="Delay posting by X seconds">
               </div>
               <?php
                  if (isset($smp_options['posting_method']) && $smp_options['posting_method'] == 'cred') {
                  ?>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Select the board where you want to automatically post your pins. To select more boards, hold down the CTRL key.", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Boards Where To Post Pins: ", 'smp-youtube-mass-poster');?></b>
                  </div>
               </td>
               <td>
                  <div>
                     <select id="board_select" class="cr_width_full" disabled name="smp_Pinterest_Settings[board_select][]" multiple>
                        <option value="random" selected><?php echo esc_html__("Random Board", 'smp-youtube-mass-poster');?></option>
                     </select>
                  </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want to post only to a single random board from the selected list of boards?", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Post Only A Single Random Board:", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <input type="checkbox" id="single_random" name="smp_Pinterest_Settings[single_random]" checked disabled>
               </div>
               <?php
                  }
                  else
                  {
                  ?>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Select the board where you want to automatically post your pins. To select more boards, hold down the CTRL key.", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Boards Where To Post Pins: ", 'smp-youtube-mass-poster');?></b><a class="cr_pointer" onclick='jQuery("#board_select").val([]);'>Clear Selection</a>
                  </div>
               </td>
               <td>
                  <div>
                     <select id="board_select" class="cr_width_full" name="smp_Pinterest_Settings[board_select][]" multiple>
                     <?php
                        $boards = get_option('smp_public_boards', false);
                        if($boards != '' && is_array($boards))
                        {
                            foreach($boards as $id => $name)
                            {
                                echo '<option value="' . esc_attr($id) . '"';
                                if($board_select != '')
                                {
                                    foreach($board_select as $bs)
                                    {
                                        if ($bs == $id) {
                                            echo " selected";
                                            break;
                                        }
                                    }
                                }
                                echo '>' . esc_html($name) . '</option>';
                            }
                        }
                        ?>
                     </select>    
                  </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want to post only to a single random board from the selected list of boards?", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Post Only A Single Random Board:", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <input type="checkbox" id="single_random" name="smp_Pinterest_Settings[single_random]"<?php
                  if ($single_random == 'on')
                      echo ' checked ';
                  ?>>
               </div>
               <?php
                  }
                  ?>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Select if you want to publish a pin for each image from the published post content. If you leave this unchecked, only the featured image will be published.", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Pin Each Image From Post Content:", 'smp-youtube-mass-poster');?></b>
                  </div>
               </td>
               <td>
                  <div>
                     <input type="checkbox" id="pin_each" name="smp_Pinterest_Settings[pin_each]"<?php
                        if ($pin_each == 'on')
                            echo ' checked ';
                        ?>>
                  </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Choose the template of your Pinterest posts. You can use the following shortcodes: %%featured_image%%, %%post_cats%%, %%post_tags%%, %%blog_title%%, %%author_name%%, %%post_link%%, %%random_sentence%%, %%random_sentence2%%, %%post_title%%, %%post_content%%, %%post_excerpt%%, %%image_search_hashtags%%", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Pinterest Post Message Template:", 'smp-youtube-mass-poster');?></b>
                  </div>
               </td>
               <td>
                  <div>
                     <textarea rows="4" class="cr_width_full" name="smp_Pinterest_Settings[pinterest_format]" placeholder="Please insert your Pinterest post template"><?php
                        echo esc_textarea($pinterest_format);
                        ?></textarea>
                  </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Input a static URL (or a comma separated list of URLs - randomly selected), where you wish to point posted pins from Pinterest. If you leave this field blank, the pins will point to the originally posted post URL.", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Static URL(s) To Point Pins To:", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <textarea rows="1" class="cr_width_full" name="smp_Pinterest_Settings[pin_urls]" placeholder="Comma separated pin URL list"><?php
                  echo esc_textarea($pin_urls);
                  ?></textarea>
               </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want to disable automatically posting of WordPress 'posts' to Pinterest?", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Disable Autoposting of 'Posts':", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <input type="checkbox" id="post_posts" name="smp_Pinterest_Settings[post_posts]"<?php
                  if ($post_posts == 'on')
                      echo ' checked ';
                  ?>>
               </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want to disable automatically posting of WordPress 'pages' to Pinterest?", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Disable Autoposting of 'Pages':", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <input type="checkbox" id="post_pages" name="smp_Pinterest_Settings[post_pages]"<?php
                  if ($post_pages == 'on')
                      echo ' checked ';
                  ?>>
               </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want to disable automatically posting of WordPress 'custom post types' to Pinterest?", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Disable Autoposting of 'Custom Post Types':", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <input type="checkbox" id="post_custom" name="smp_Pinterest_Settings[post_custom]"<?php
                  if ($post_custom == 'on')
                      echo ' checked ';
                  ?>>
               </div>
               </td>
            </tr><tr><td>
                    <div>
        <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                        <div class="bws_hidden_help_text cr_min_260px">
<?php
    echo esc_html__("If you checked the above checkbox to disable processing of custom post types, you can define here a comma separated list of posts types which should still be process (excepted from skipping).", 'smp-youtube-mass-poster');
?>
                        </div>
                    </div>
                    <b><?php echo esc_html__("Excepting This Comma Separated List Of Custom Post Types:", 'smp-youtube-mass-poster');?></b>
                    
                    </td><td>
                    <input type="text" id="except_type" name="smp_Pinterest_Settings[except_type]" value="<?php echo esc_html($except_type);?>" placeholder="Excepted custom post types">
        </td></tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want to disable automatically posting of WordPress 'posts' to Pinterest?", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Disable Autoposting of Selected Categories:", 'smp-youtube-mass-poster');?></b><br/>
                     <a onclick="toggleCats()" class="cr_pointer"><?php echo esc_html__("Show/Hide Categories List", 'smp-youtube-mass-poster');?></a>
               </td>
               <td>
               <br/>
               <div id="hideCats" class="hideCats">
               <?php
                  $cat_args   = array(
                      'orderby' => 'name',
                      'hide_empty' => 0,
                      'order' => 'ASC'
                  );
                  $categories = get_categories($cat_args);
                  foreach ($categories as $category) {
                  ?>
               <div>
               <label>
               <input
                  <?php
                     if (isset($smp_Pinterest_Settings['disabled_categories']) && !empty($smp_Pinterest_Settings['disabled_categories'])) {
                         checked(true, in_array($category->term_id, $smp_Pinterest_Settings['disabled_categories']));
                     }
                     ?>
                  type="checkbox" name="smp_Pinterest_Settings[disabled_categories][]" value="<?php
                     echo esc_html($category->term_id);
                     ?>" /> 
               <span><?php
                  echo esc_html(sanitize_text_field($category->name));
                  ?></span>
               </label>
               </div>
               <?php
                  }
                  ?>
               </div>
               </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Input the tags for which you want to disable posting. You can enter more tags, separated by comma. Ex: cars, vehicles, red, luxury. To disable this feature, leave this field blank.", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Disable Autoposting of Selected Tags:", 'smp-youtube-mass-poster');?></b>
                  </div>
               </td>
               <td>
                  <div>
                     <textarea rows="1" class="cr_width_full" name="smp_Pinterest_Settings[disable_tags]" placeholder="Please insert the tags for which you want to disable posting"><?php
                        echo esc_textarea($disable_tags);
                        ?></textarea>
                  </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want to post only local media (that reside on your host)?", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Post Only Local Media:", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <input type="checkbox" id="only_local" name="smp_Pinterest_Settings[only_local]"<?php
                  if ($only_local == 'on')
                      echo ' checked ';
                  ?>>
               </div>
               </td>
            </tr>
            <tr>
               <td>
                  <div>
                     <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                        <div class="bws_hidden_help_text cr_min_260px">
                           <?php
                              echo esc_html__("Do you want to use a proxy list for requests? To disable this feature, leave this field blank. Please use this format: proxy_IP:proxy_port, proxy_IP:proxy_port:user:pass", 'smp-youtube-mass-poster');
                              ?>
                        </div>
                     </div>
                     <b><?php echo esc_html__("Comma Separated Proxy List To Use For Requests:", 'smp-youtube-mass-poster');?></b>
               </td>
               <td>
               <textarea rows="4" class="cr_width_full" name="smp_Pinterest_Settings[proxy_list]" placeholder="Please insert a proxy list"><?php
                  echo esc_textarea($proxy_list);
                  ?></textarea>
               </div>
               </td>
            </tr>
         </table>
         <br/><br/>
         <div>
            <b><?php echo esc_html__("Help! Plugin configured and still no posts appearing on Pinterest?", 'smp-youtube-mass-poster');?></b>
            <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
               <div class="bws_hidden_help_text cr_min_260px">
                  <?php
                     if (isset($smp_options['posting_method']) && $smp_options['posting_method'] == 'cred') {
                         echo esc_html__("In this case you can try the following: Check Your user name and password. Make sure they are correct.", 'smp-youtube-mass-poster');
                     }
                     else
                     {
                         echo esc_html__("In this case you can try the following: Check Your API key and secret. Make sure they are correct.", 'smp-youtube-mass-poster');
                     }
                     ?>
               </div>
            </div>
         </div>
      </div>
      <div>
         <p class="crsubmit"><input type="submit" name="btnSubmit" id="btnSubmit" class="button button-primary" onclick="unsaved = false;" value="<?php echo esc_html__("Save Settings", 'smp-youtube-mass-poster');?>"/></p>
      </div>
</form>
</div>
<?php
   }
   }
   ?>